#include <Misc.au3>
#include "OOPGDIP.au3"

Opt("GUIOnEventMode", 1)

Global $hGUI, $aCoords[2] = [600, 400]
Global $oGraphic, $oBuffer, $oBrush
Global $oPlayer1, $oPlayer2, $oBall
Global $aBallv[2], $aPlayerScore[2] = [0, 0]

_StartUp()

While 1
	Sleep(5)
	_CalcGame()
	_DrawGame()
WEnd

Func _DrawGame()
	$oBuffer.clear
	$oPlayer1.draw
	$oPlayer2.draw
	$oBall.draw
	$oBuffer.draw
EndFunc   ;==>_DrawGame

Func _CalcGame()
	If _IsPressed(57) And $oPlayer1.yPos >= 0 Then $oPlayer1.yPos = $oPlayer1.yPos - 7.5
	If _IsPressed(53) And $oPlayer1.yPos + $oPlayer1.height <= $aCoords[1] Then $oPlayer1.yPos = $oPlayer1.yPos + 7.5
	If _IsPressed(26) And $oPlayer2.yPos >= 0 Then $oPlayer2.yPos = $oPlayer2.yPos - 7.5
	If _IsPressed(28) And $oPlayer2.yPos + $oPlayer2.height <= $aCoords[1] Then $oPlayer2.yPos = $oPlayer2.yPos + 7.5

	$oBall.xPos = $oBall.xPos + $aBallv[0]
	$oBall.yPos = $oBall.yPos + $aBallv[1]

	If $oBall.yPos <= 0 Then $aBallv[1] = -$aBallv[1]
	If $oBall.yPos + $oBall.width >= $aCoords[1] Then $aBallv[1] = -$aBallv[1]

	If $oBall.xPos <= $oPlayer1.xPos + $oPlayer1.width And $oBall.yPos >= $oPlayer1.yPos And $oBall.yPos <= $oPlayer1.yPos + $oPlayer1.height Then $aBallv[0] = -$aBallv[0]
	If $oBall.xPos + $oBall.width >= $oPlayer2.xPos And $oBall.yPos >= $oPlayer2.yPos And $oBall.yPos <= $oPlayer2.yPos + $oPlayer2.height Then $aBallv[0] = -$aBallv[0]

	If $oBall.xPos <= 0 Then
		$aPlayerScore[1] += 1
		_ResetGame()
	ElseIf $oBall.xPos >= $aCoords[0] Then
		$aPlayerScore[0] += 1
		_ResetGame()
	EndIf

EndFunc   ;==>_CalcGame

Func _ResetGame()
	$oPlayer1.yPos = $aCoords[1] / 2 - $oPlayer1.height / 2
	$oPlayer2.yPos = $aCoords[1] / 2 - $oPlayer2.height / 2

	$oBall.xPos = $aCoords[0] / 2 - $oBall.width / 2
	$oBall.yPos = $aCoords[1] / 2 - $oBall.width / 2

	$aBallv[0] = Random(6, 10)
	$aBallv[1] = 6 - ($aBallv[0] - 4)

	If Random(0, 1, 1) Then $aBallv[0] = -$aBallv[0]
	If Random(0, 1, 1) Then $aBallv[1] = -$aBallv[1]

	WinSetTitle($hGUI, "", "OOPGDIP - PingPong ~ Score " & $aPlayerScore[0] & ":" & $aPlayerScore[1])
	_DrawGame()
	Sleep(1000)
EndFunc   ;==>_ResetGame

Func _StartUp()
	_OOPGDIP_StartUp()

	$hGUI = GUICreate("OOPGDIP - PingPong", $aCoords[0], $aCoords[1], -1, -1)
	GUISetBkColor(0x000000)
	GUISetOnEvent(-3, "_Exit")
	GUISetState(@SW_SHOW)

	$oGraphic = _OOPGDIP_GraphicsCreate($hGUI)
	$oBuffer = _OOPGDIP_BufferCreate($oGraphic, 600, 400, 0x22000000, 4)
	$oBrush = _OOPGDIP_BrushCreate(0xFFFFFFFF)

	$oPlayer1 = _OOPGDIP_FilledRectCreate($oBuffer, 5, $aCoords[1] / 2 - 50, 3, 100, $oBrush)
	$oPlayer2 = _OOPGDIP_FilledRectCreate($oBuffer, $aCoords[0] - 9, $aCoords[1] / 2 - 50, 3, 100, $oBrush)
	$oBall = _OOPGDIP_FilledEllipseCreate($oBuffer, 0, 0, 5, 5, $oBrush)

	_ResetGame()
EndFunc   ;==>_StartUp

Func _Exit()
	$oBrush.dispose
	$oBuffer.dispose
	$oGraphic.dispose
	_OOPGDIP_ShutDown()
	Exit
EndFunc   ;==>_Exit